--- a/arch/mips/bcm63xx/dev-flash.c
+++ b/arch/mips/bcm63xx/dev-flash.c
@@ -271,8 +271,12 @@ int __init bcm63xx_flash_register(void)
 			return -ENODEV;
 		}
 	case BCM63XX_FLASH_TYPE_NAND:
-		pr_warn("unsupported NAND flash detected\n");
-		return -ENODEV;
+		if (board_of_device_present("nflash")) {
+			return 0;
+		} else {
+			pr_warn("unsupported NAND flash detected\n");
+			return -ENODEV;
+		}
 	default:
 		pr_err("flash detection failed for BCM%x: %d\n",
 		       bcm63xx_get_cpu_id(), flash_type);
